//
//  BJPUAppearance.h
//  Pods
//
//  Created by DLM on 2017/4/26.
//
//

#import <Foundation/Foundation.h>
#import <sys/utsname.h>

@interface UIColor (BJPU)

+ (UIColor *)bjpu_colorWithHexString:(NSString *)color alpha:(CGFloat)alpha;

+ (UIColor *)bjpu_colorWithHexString:(NSString *)color;

+ (instancetype)bjpu_brandColor;

@end

@interface UIImage (BJPU)

+ (UIImage *)bjpu_imageNamed:(NSString *)name;

@end

@interface NSString (BJPU)

+ (NSString *)stringFromTimeInterval:(NSTimeInterval)interval;

+ (NSString *)stringFromTimeInterval:(NSTimeInterval)interval totalTimeInterval:(NSTimeInterval)total;
@end

static inline BOOL bjpu_iPhoneX() {
    static BOOL iPhoneX = NO;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
#if TARGET_OS_EMBEDDED
        struct utsname systemInfo;
        uname(&systemInfo);
        NSString *machine = @(systemInfo.machine);
        iPhoneX = ([machine isEqualToString:@"iPhone10,3"]
                   || [machine isEqualToString:@"iPhone10,6"]);
#else // TARGET_OS_SIMULATOR
        CGSize screenSize = [UIScreen mainScreen].bounds.size;
        iPhoneX = ABS(MAX(screenSize.width, screenSize.height) - 812.0) <= CGFLOAT_MIN;
#endif
    });
    return iPhoneX;
}
